dnl S-News version 0.1.9 - A Simple News Server
dnl Copyright (C) 1998 Christopher John Purnell
dnl                    cjp@lost.org.uk
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

AC_DEFUN(SN_CONFDIR,[
AC_ARG_WITH(confdir,[  --with-confdir=DIR      configuration directory [/var/lib/news]],confdir="$withval",confdir=/var/lib/news)
AC_SUBST(confdir)
AC_DEFINE_UNQUOTED(CONFDIR,"$confdir")
])

AC_DEFUN(SN_SPOOLDIR,[
AC_ARG_WITH(spooldir,[  --with-spooldir=DIR     spool directory [/var/spool/news]],spooldir="$withval",spooldir=/var/spool/news)
AC_SUBST(spooldir)
AC_DEFINE_UNQUOTED(SPOOLDIR,"$spooldir")
])

AC_DEFUN(SN_INSTALL,[
test -z "$INSTALL_DIRECTORY" && INSTALL_DIRECTORY="${INSTALL% -c} -d"
AC_SUBST(INSTALL_DIRECTORY)
test -z "$INSTALL_VARDATA" && INSTALL_VARDATA='${INSTALL}'
AC_SUBST(INSTALL_VARDATA)
test -z "$INSTALL_VARDIR" && INSTALL_VARDIR='${INSTALL_DIRECTORY}'
AC_SUBST(INSTALL_VARDIR)
])

AC_DEFUN(SN_USER,[
AC_ARG_WITH(user,[  --with-user=USER        user [news]],USER="$withval",USER=yes)
if test "$USER" = no
then
 USER=""
else
test "$USER" = yes && USER=news
AC_TRY_RUN([
#include <pwd.h>
int main()
{
 return (getpwnam("$USER") == 0);
}],AC_DEFINE_UNQUOTED(USER,"$USER"),USER="",
AC_DEFINE_UNQUOTED(USER,"$USER"))
fi
if test "x$USER" != x
then
 INSTALL_VARDATA="$INSTALL_VARDATA -o $USER"
 INSTALL_VARDIR="$INSTALL_VARDIR -o $USER"
fi
AC_SUBST(USER)
])

AC_DEFUN(SN_GROUP,[
AC_ARG_WITH(group,[  --with-group=GROUP      group [news]],GROUP="$withval",GROUP=yes)
if test "$GROUP" = no
then
 GROUP=""
else
test "$GROUP" = yes && GROUP=news
AC_TRY_RUN([
#include <grp.h>
int main()
{
 return (getgrnam("$GROUP") == 0);
}],AC_DEFINE_UNQUOTED(GROUP,"$GROUP"),GROUP="",
AC_DEFINE_UNQUOTED(GROUP,"$GROUP"))
fi
if test "x$GROUP" != x
then
 INSTALL_VARDATA="$INSTALL_VARDATA -g $GROUP"
 INSTALL_VARDIR="$INSTALL_VARDIR -g $GROUP"
fi
AC_SUBST(GROUP)
])

AC_DEFUN(SN_UMASK,[
AC_ARG_WITH(umask,[  --with-umask=UMASK      umask [022]],UMASK="$withval",UMASK=yes)
if test "$UMASK" = no
then
 UMASK=""
else
test "$UMASK" = yes && UMASK=022
UMASK=`echo $UMASK | sed 's/^0*/0/'`
AC_TRY_RUN([
int main()
{
 umask($UMASK);
 return 0;
}],AC_DEFINE_UNQUOTED(UMASK,$UMASK),UMASK="",
AC_DEFINE_UNQUOTED(UMASK,$UMASK))
fi
case "x${UMASK}" in
x)
 INSTALL_VARDATA="$INSTALL_VARDATA -m 644"
 ;;
x022)
 INSTALL_VARDATA="$INSTALL_VARDATA -m 644"
 INSTALL_VARDIR="$INSTALL_VARDIR -m 755"
 ;;
x02)
 INSTALL_VARDATA="$INSTALL_VARDATA -m 664"
 INSTALL_VARDIR="$INSTALL_VARDIR -m 775"
 ;;
*)
 INSTALL_VARDATA="$INSTALL_VARDATA -m "`perl -e "printf '%o',0666 & ~$UMASK"`
 INSTALL_VARDIR="$INSTALL_VARDIR -m "`perl -e "printf '%o',0777 & ~$UMASK"`
 ;;
esac
AC_SUBST(UMASK)
])

AC_DEFUN(SN_BINDIR,[
ac_save_prefix="$prefix"
ac_save_exec_prefix="$exec_prefix"

test "x$prefix" = xNONE && prefix=$ac_default_prefix
test "x$exec_prefix" = xNONE && exec_prefix=$prefix

BINDIR=`eval echo $bindir`
SBINDIR=`eval echo $sbindir`

AC_DEFINE_UNQUOTED(BINDIR,"$BINDIR")
AC_DEFINE_UNQUOTED(SBINDIR,"$SBINDIR")

prefix="$ac_save_prefix"
exec_prefix="$ac_save_exec_prefix"
])
